package com.madeu.controller.web.webstockclosedetail;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webstockclosedetail.WebStockCloseDetailService;
import com.madeu.util.HttpUtil;
import com.madeu.view.web.WebStockCloseDetailView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebStockCloseDetailController extends ManagerDraftAction{

	@Autowired
	private WebStockCloseDetailService webStockCloseDetailService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	/**
	 * 재고마감 상세 리스트 조회 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockclosedetail/selectListStockCloseDetailIntro.do")
	public String  selectListStockCloseDetailIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebStockCloseDetailController  selectListStockCloseDetailIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockCloseDetailService.selectListStockCloseDetailIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebStockCloseDetailController  selectListStockCloseDetailIntro END");
		return "/web/stockclosedetail/stockCloseDetailSelectList";
	}
	
	/**
	 * 재고마감 상세 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockclosedetail/selectListStockCloseDetail.do")
	public ModelAndView selectListStockCloseDetail(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockCloseDetailController selectListStockCloseDetail START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockCloseDetailService.selectListStockCloseDetail(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockCloseDetailController selectListStockCloseDetail END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * <b> 재고마감 상세 리스트 조회 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockclosedetail/downloadStockCloseDetailExcel.do")
	public ModelAndView downloadStockCloseDetailExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebStockCloseDetailController downloadStockCloseDetailExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		Map<String, Object> selectListReport = new HashMap<String,Object>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webStockCloseDetailService.selectListStockCloseDetailExcel(paramMap);
				map.put("selectListStockCloseDetail", selectListReport);
				map.put("name", "stockclosedetail");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebStockCloseDetailController downloadStockCloseDetailExcel END");
		return new ModelAndView(new WebStockCloseDetailView(),"map",map);
	}
	/**
	 * 현재고 품목수, 품목별재고수, 거래처수, 재고총액 조회 (현재고 상단)
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webstockclosedetail/selectTotalStockCloseDetail.do")
	public ModelAndView selectTotalStockCloseDetail(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumController selectTotalStockCloseDetail START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockCloseDetailService.selectTotalStockCloseDetail(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumController selectTotalStockCloseDetail END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}
